use dyn_clone::DynClone;
use grammers_client::Update;

pub trait Filter: DynClone + Send + Sync {
    fn filter(&self, update: &Update) -> anyhow::Result<bool>;
}

dyn_clone::clone_trait_object!(Filter);

impl<T> Filter for T
where
    T: Fn(&Update) -> anyhow::Result<bool> + Clone + Send + Sync,
{
    fn filter(&self, update: &Update) -> anyhow::Result<bool> {
        self(update)
    }
}
