use grammers_client::{Client, Update};

use crate::{bot::handlers::Handler, utils::messages::get_message};

#[derive(Clone)]
pub struct GetChatId;

#[async_trait::async_trait]
impl Handler for GetChatId {
    async fn react(&self, _: &Client, update: &Update) -> anyhow::Result<()> {
        let message = get_message(update);
        if let Some(msg) = message {
            msg.reply(msg.chat().id().to_string()).await?;
        }
        Ok(())
    }
}
