use crate::{
    bot::handlers::Handler,
    utils::{inter_join::RandomIntersperse, messages::get_message},
};
use grammers_client::{Client, InputMessage, Update};

const BLYA_WORDS: &[&str] = &[", бля,", ", сука,", ", ёбаный рот,", ", охуеть конечно,"];

/// It's time to add some бляs.
#[derive(Clone)]
pub struct Blyaficator;

#[async_trait::async_trait]
impl Handler for Blyaficator {
    async fn react(&self, _: &Client, update: &Update) -> anyhow::Result<()> {
        if let Some(message) = get_message(update) {
            let maybe_blyaficated = message.text().strip_prefix(".bl").map(|stripped| {
                stripped
                    // Trim string after removing prefix, to
                    // remove leading spaces.
                    .trim()
                    // split by commas
                    .split(',')
                    // choose random strings from BLYA_WORDS
                    // and insert them between splitted strings.
                    .random_itersperse(BLYA_WORDS, &mut rand::rngs::OsRng)
                    // Collect it back to vec
                    .collect::<Vec<_>>()
                    // Creating one string with all words concatenated.
                    .join("")
            });

            // If the text was blyaficated we send it as a reply.
            if let Some(blyficated) = maybe_blyaficated {
                message
                    .reply(InputMessage::from(blyficated).silent(true))
                    .await?;
            }
        }
        Ok(())
    }
}
